Index: /NEMO/trunk/src/SWE/sbcice_cice.F90
===================================================================
--- /NEMO/trunk/src/SWE/sbcice_cice.F90	(revision 13294)
+++ /NEMO/trunk/src/SWE/sbcice_cice.F90	(revision 13295)
@@ -219,5 +219,5 @@
 ! T point to U point
 ! T point to V point
-      DO_2D_10_10
+      DO_2D( 1, 0, 1, 0 )
          fr_iu(ji,jj)=0.5*(fr_i(ji,jj)+fr_i(ji+1,jj))*umask(ji,jj,1)
          fr_iv(ji,jj)=0.5*(fr_i(ji,jj)+fr_i(ji,jj+1))*vmask(ji,jj,1)
@@ -316,5 +316,5 @@
 ! x comp of wind stress (CI_1)
 ! U point to F point
-         DO_2D_10_11
+         DO_2D( 1, 0, 1, 1 )
             ztmp(ji,jj) = 0.5 * (  fr_iu(ji,jj) * utau(ji,jj)      &
                                  + fr_iu(ji,jj+1) * utau(ji,jj+1) ) * fmask(ji,jj,1)
@@ -324,5 +324,5 @@
 ! y comp of wind stress (CI_2)
 ! V point to F point
-         DO_2D_11_10
+         DO_2D( 1, 1, 1, 0 )
             ztmp(ji,jj) = 0.5 * (  fr_iv(ji,jj) * vtau(ji,jj)      &
                                  + fr_iv(ji+1,jj) * vtau(ji+1,jj) ) * fmask(ji,jj,1)
@@ -339,5 +339,5 @@
             qla_ice(:,:,1)= - ( emp_ice(:,:)+sprecip(:,:) ) * rLsub
 ! End of temporary code
-            DO_2D_11_11
+            DO_2D( 1, 1, 1, 1 )
                IF(fr_i(ji,jj).eq.0.0) THEN
                   DO jl=1,ncat
@@ -441,5 +441,5 @@
 ! x comp and y comp of surface ocean current
 ! U point to F point
-      DO_2D_10_11
+      DO_2D( 1, 0, 1, 1 )
          ztmp(ji,jj)=0.5*(ssu_m(ji,jj)+ssu_m(ji,jj+1))*fmask(ji,jj,1)
       END_2D
@@ -447,5 +447,5 @@
 
 ! V point to F point
-      DO_2D_11_10
+      DO_2D( 1, 1, 1, 0 )
          ztmp(ji,jj)=0.5*(ssv_m(ji,jj)+ssv_m(ji+1,jj))*fmask(ji,jj,1)
       END_2D
@@ -471,5 +471,5 @@
 ! x comp and y comp of sea surface slope (on F points)
 ! T point to F point
-      DO_2D_10_10
+      DO_2D( 1, 0, 1, 0 )
          ztmp(ji,jj)=0.5 * (  (zpice(ji+1,jj  )-zpice(ji,jj  )) * r1_e1u(ji,jj  )    &
             &               + (zpice(ji+1,jj+1)-zpice(ji,jj+1)) * r1_e1u(ji,jj+1)  ) * fmask(ji,jj,1)
@@ -478,5 +478,5 @@
 
 ! T point to F point
-      DO_2D_10_10
+      DO_2D( 1, 0, 1, 0 )
          ztmp(ji,jj)=0.5 * (  (zpice(ji  ,jj+1)-zpice(ji  ,jj)) * r1_e2v(ji  ,jj)    &
             &               + (zpice(ji+1,jj+1)-zpice(ji+1,jj)) * r1_e2v(ji+1,jj)  ) *  fmask(ji,jj,1)
@@ -507,5 +507,5 @@
       ss_iou(:,:)=0.0
 ! F point to U point
-      DO_2D_00_00
+      DO_2D( 0, 0, 0, 0 )
          ss_iou(ji,jj) = 0.5 * ( ztmp1(ji,jj-1) + ztmp1(ji,jj) ) * umask(ji,jj,1)
       END_2D
@@ -517,5 +517,5 @@
 ! F point to V point
 
-      DO_2D_10_00
+      DO_2D( 1, 0, 0, 0 )
          ss_iov(ji,jj) = 0.5 * ( ztmp1(ji-1,jj) + ztmp1(ji,jj) ) * vmask(ji,jj,1)
       END_2D
@@ -601,5 +601,5 @@
       CALL lbc_lnk( 'sbcice_cice', qsr , 'T', 1. )
 
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
          nfrzmlt(ji,jj)=MAX(nfrzmlt(ji,jj),0.0)
       END_2D
@@ -625,5 +625,5 @@
 ! T point to U point
 ! T point to V point
-      DO_2D_10_10
+      DO_2D( 1, 0, 1, 0 )
          fr_iu(ji,jj)=0.5*(fr_i(ji,jj)+fr_i(ji+1,jj))*umask(ji,jj,1)
          fr_iv(ji,jj)=0.5*(fr_i(ji,jj)+fr_i(ji,jj+1))*vmask(ji,jj,1)
@@ -985,5 +985,5 @@
 
       pn(:,:)=0.0
-      DO_2D_10_10
+      DO_2D( 1, 0, 1, 0 )
          pn(ji,jj)=pc(ji+1-ji_off,jj+1-jj_off,1)
       END_2D
Index: /NEMO/trunk/src/SWE/step.F90
===================================================================
--- /NEMO/trunk/src/SWE/step.F90	(revision 13294)
+++ /NEMO/trunk/src/SWE/step.F90	(revision 13295)
@@ -148,5 +148,5 @@
 
 !!an - calcul du gradient de pression horizontal (explicit)
-      DO_3D_00_00( 1, jpkm1 )
+      DO_3D( 0, 0, 0, 0, 1, jpkm1 )
          uu(ji,jj,jk,Nrhs) = uu(ji,jj,jk,Nrhs) - grav * ( ssh(ji+1,jj,Nnn) - ssh(ji,jj,Nnn) ) * r1_e1u(ji,jj)
          vv(ji,jj,jk,Nrhs) = vv(ji,jj,jk,Nrhs) - grav * ( ssh(ji,jj+1,Nnn) - ssh(ji,jj,Nnn) ) * r1_e2v(ji,jj)
@@ -155,5 +155,5 @@
       ! add wind stress forcing and layer linear friction to the RHS 
       z1_2rho0 = 0.5_wp * r1_rho0
-      DO_3D_00_00(1,jpkm1)
+      DO_3D( 0, 0, 0, 0,1,jpkm1)
          uu(ji,jj,jk,Nrhs) = uu(ji,jj,jk,Nrhs) + z1_2rho0 * ( utau_b(ji,jj) + utau(ji,jj) ) / e3u(ji,jj,jk,Nnn)   &
             &                                  - rn_rfr * uu(ji,jj,jk,Nbb)
@@ -172,10 +172,10 @@
       IF( ln_dynadv_vec ) THEN      ! vector invariant form : applied on velocity
          IF( l_1st_euler ) THEN           ! Euler time stepping (no Asselin filter)
-            DO_3D_00_00(1,jpkm1)
+            DO_3D( 0, 0, 0, 0,1,jpkm1)
                uu(ji,jj,jk,Naa) = uu(ji,jj,jk,Nbb) + rDt * uu(ji,jj,jk,Nrhs) * umask(ji,jj,jk)
                vv(ji,jj,jk,Naa) = vv(ji,jj,jk,Nbb) + rDt * vv(ji,jj,jk,Nrhs) * vmask(ji,jj,jk)
              END_3D          
          ELSE                             ! Leap Frog time stepping + Asselin filter         
-            DO_3D_11_11(1,jpkm1)
+            DO_3D( 1, 1, 1, 1,1,jpkm1)
                zua = uu(ji,jj,jk,Nbb) + rDt * uu(ji,jj,jk,Nrhs) * umask(ji,jj,jk)
                zva = vv(ji,jj,jk,Nbb) + rDt * vv(ji,jj,jk,Nrhs) * vmask(ji,jj,jk)
@@ -199,5 +199,5 @@
       ELSE                          ! flux form : applied on thickness weighted velocity
          IF( l_1st_euler ) THEN           ! Euler time stepping (no Asselin filter)
-            DO_3D_00_00(1,jpkm1)
+            DO_3D( 0, 0, 0, 0,1,jpkm1)
                zue3b = e3u(ji,jj,jk,Nbb) * uu(ji,jj,jk,Nbb)
                zve3b = e3v(ji,jj,jk,Nbb) * vv(ji,jj,jk,Nbb)
@@ -210,5 +210,5 @@
             END_3D
          ELSE                             ! Leap Frog time stepping + Asselin filter
-            DO_3D_11_11(1,jpkm1)
+            DO_3D( 1, 1, 1, 1,1,jpkm1)
                zue3n = e3u(ji,jj,jk,Nnn) * uu(ji,jj,jk,Nnn)
                zve3n = e3v(ji,jj,jk,Nnn) * vv(ji,jj,jk,Nnn)
Index: /NEMO/trunk/src/SWE/stepLF.F90
===================================================================
--- /NEMO/trunk/src/SWE/stepLF.F90	(revision 13294)
+++ /NEMO/trunk/src/SWE/stepLF.F90	(revision 13295)
@@ -146,5 +146,5 @@
       !IF( .NOT.ln_linssh )  CALL dom_vvl_sf_nxt_st( kstp, Nbb, Nnn,      Naa )    ! after vertical scale factors 
 !!an - calcul du gradient de pression horizontal (explicit)
-      DO_3D_00_00( 1, jpkm1 )
+      DO_3D( 0, 0, 0, 0, 1, jpkm1 )
          uu(ji,jj,jk,Nrhs) = uu(ji,jj,jk,Nrhs) - grav * ( ssh(ji+1,jj,Nnn) - ssh(ji,jj,Nnn) ) * r1_e1u(ji,jj)
          vv(ji,jj,jk,Nrhs) = vv(ji,jj,jk,Nrhs) - grav * ( ssh(ji,jj+1,Nnn) - ssh(ji,jj,Nnn) ) * r1_e2v(ji,jj)
@@ -153,5 +153,5 @@
       ! add wind stress forcing and layer linear friction to the RHS 
       z1_2rho0 = 0.5_wp * r1_rho0
-      DO_3D_00_00(1,jpkm1)
+      DO_3D( 0, 0, 0, 0,1,jpkm1)
          uu(ji,jj,jk,Nrhs) = uu(ji,jj,jk,Nrhs) + z1_2rho0 * ( utau_b(ji,jj) + utau(ji,jj) ) / e3u(ji,jj,jk,Nnn)   &
             &                                  - rn_rfr * uu(ji,jj,jk,Nbb)
@@ -176,10 +176,10 @@
       IF( ln_dynadv_vec ) THEN      ! vector invariant form : applied on velocity
          IF( l_1st_euler ) THEN           ! Euler time stepping (no Asselin filter)
-            DO_3D_00_00(1,jpkm1)
+            DO_3D( 0, 0, 0, 0,1,jpkm1)
                uu(ji,jj,jk,Naa) = uu(ji,jj,jk,Nbb) + rDt * uu(ji,jj,jk,Nrhs) * umask(ji,jj,jk)
                vv(ji,jj,jk,Naa) = vv(ji,jj,jk,Nbb) + rDt * vv(ji,jj,jk,Nrhs) * vmask(ji,jj,jk)
              END_3D          
          ELSE                             ! Leap Frog time stepping + Asselin filter         
-            DO_3D_11_11(1,jpkm1)
+            DO_3D( 1, 1, 1, 1,1,jpkm1)
                zua = uu(ji,jj,jk,Nbb) + rDt * uu(ji,jj,jk,Nrhs) * umask(ji,jj,jk)
                zva = vv(ji,jj,jk,Nbb) + rDt * vv(ji,jj,jk,Nrhs) * vmask(ji,jj,jk)
@@ -203,5 +203,5 @@
       ELSE                          ! flux form : applied on thickness weighted velocity
          IF( l_1st_euler ) THEN           ! Euler time stepping (no Asselin filter)
-            DO_3D_00_00(1,jpkm1)
+            DO_3D( 0, 0, 0, 0,1,jpkm1)
                zue3b = e3u(ji,jj,jk,Nbb) * uu(ji,jj,jk,Nbb)
                zve3b = e3v(ji,jj,jk,Nbb) * vv(ji,jj,jk,Nbb)
@@ -215,5 +215,5 @@
          ELSE                             ! Leap Frog time stepping + Asselin filter
             CALL dom_qco_r3c( ssh(:,:,Nnn), r3t_f(:,:), r3u_f(:,:), r3v_f(:,:) )   ! "now" ssh/h_0 ratio from filtrered ssh
-            DO_3D_11_11(1,jpkm1)
+            DO_3D( 1, 1, 1, 1,1,jpkm1)
                zue3n = e3u(ji,jj,jk,Nnn) * uu(ji,jj,jk,Nnn)
                zve3n = e3v(ji,jj,jk,Nnn) * vv(ji,jj,jk,Nnn)
Index: /NEMO/trunk/src/SWE/stpRK3.F90
===================================================================
--- /NEMO/trunk/src/SWE/stpRK3.F90	(revision 13294)
+++ /NEMO/trunk/src/SWE/stpRK3.F90	(revision 13295)
@@ -145,5 +145,5 @@
       !
 !!an - calcul du gradient de pression horizontal (explicit)
-      DO_3D_00_00( 1, jpkm1 )
+      DO_3D( 0, 0, 0, 0, 1, jpkm1 )
          uu(ji,jj,jk,Nrhs) = uu(ji,jj,jk,Nrhs) - grav * ( ssh(ji+1,jj,Nbb) - ssh(ji,jj,Nbb) ) * r1_e1u(ji,jj)
          vv(ji,jj,jk,Nrhs) = vv(ji,jj,jk,Nrhs) - grav * ( ssh(ji,jj+1,Nbb) - ssh(ji,jj,Nbb) ) * r1_e2v(ji,jj)
@@ -153,5 +153,5 @@
       ! add wind stress forcing and layer linear friction to the RHS 
       z5_6 = 5._wp/6._wp
-      DO_3D_00_00(1,jpkm1)
+      DO_3D( 0, 0, 0, 0,1,jpkm1)
          uu(ji,jj,jk,Nrhs) = uu(ji,jj,jk,Nrhs) + r1_rho0 * ( z5_6*utau_b(ji,jj) + (1._wp - z5_6)*utau(ji,jj) ) / e3u(ji,jj,jk,Nbb)   &
             &                                  - rn_rfr * uu(ji,jj,jk,Nbb)
@@ -163,10 +163,10 @@
                             CALL dom_qco_r3c   ( ssh(:,:,Naa), r3t(:,:,Naa), r3u(:,:,Naa), r3v(:,:,Naa), r3f(:,:) )   ! "after" ssh./h._0 ratio explicit
       IF( ln_dynadv_vec ) THEN      ! vector invariant form : applied on velocity
-         DO_3D_00_00(1,jpkm1)
+         DO_3D( 0, 0, 0, 0,1,jpkm1)
             uu(ji,jj,jk,Naa) = uu(ji,jj,jk,Nbb) + rDt * uu(ji,jj,jk,Nrhs) * umask(ji,jj,jk)
             vv(ji,jj,jk,Naa) = vv(ji,jj,jk,Nbb) + rDt * vv(ji,jj,jk,Nrhs) * vmask(ji,jj,jk)
          END_3D          
       ELSE
-         DO_3D_00_00(1,jpkm1)       ! flux form : applied on thickness weighted velocity
+         DO_3D( 0, 0, 0, 0,1,jpkm1)       ! flux form : applied on thickness weighted velocity
             uu(ji,jj,jk,Naa) = (         uu(ji,jj,jk,Nbb )*e3u(ji,jj,jk,Nbb)                              &
                &                 + rDt * uu(ji,jj,jk,Nrhs)*e3t(ji,jj,jk,Nbb) * umask(ji,jj,jk)        )   &
@@ -203,5 +203,5 @@
       !
 !!an - calcul du gradient de pression horizontal (explicit)
-      DO_3D_00_00( 1, jpkm1 )
+      DO_3D( 0, 0, 0, 0, 1, jpkm1 )
          uu(ji,jj,jk,Nrhs) = uu(ji,jj,jk,Nrhs) - grav * ( ssh(ji+1,jj,Nnn) - ssh(ji,jj,Nnn) ) * r1_e1u(ji,jj)
          vv(ji,jj,jk,Nrhs) = vv(ji,jj,jk,Nrhs) - grav * ( ssh(ji,jj+1,Nnn) - ssh(ji,jj,Nnn) ) * r1_e2v(ji,jj)
@@ -211,5 +211,5 @@
 #if defined key_RK3all
       z3_4 = 3._wp/4._wp
-      DO_3D_00_00(1,jpkm1)
+      DO_3D( 0, 0, 0, 0,1,jpkm1)
          uu(ji,jj,jk,Nrhs) = uu(ji,jj,jk,Nrhs) + r1_rho0 * ( z3_4*utau_b(ji,jj) + (1._wp - z3_4)*utau(ji,jj) ) / e3u(ji,jj,jk,Nbb)   &
             &                                  - rn_rfr * uu(ji,jj,jk,Nbb)
@@ -221,10 +221,10 @@
                            CALL dom_qco_r3c   ( ssh(:,:,Naa), r3t(:,:,Naa), r3u(:,:,Naa), r3v(:,:,Naa), r3f(:,:) )   ! "after" ssh./h._0 ratio explicit
       IF( ln_dynadv_vec ) THEN      ! vector invariant form : applied on velocity
-         DO_3D_00_00(1,jpkm1)
+         DO_3D( 0, 0, 0, 0,1,jpkm1)
             uu(ji,jj,jk,Naa) = uu(ji,jj,jk,Nbb) + rDt * uu(ji,jj,jk,Nrhs) * umask(ji,jj,jk)
             vv(ji,jj,jk,Naa) = vv(ji,jj,jk,Nbb) + rDt * vv(ji,jj,jk,Nrhs) * vmask(ji,jj,jk)
          END_3D          
       ELSE
-         DO_3D_00_00(1,jpkm1)       ! flux form : applied on thickness weighted velocity
+         DO_3D( 0, 0, 0, 0,1,jpkm1)       ! flux form : applied on thickness weighted velocity
             uu(ji,jj,jk,Naa) = (         uu(ji,jj,jk,Nbb )*e3u(ji,jj,jk,Nbb)                              &
                &                 + rDt * uu(ji,jj,jk,Nrhs)*e3t(ji,jj,jk,Nnn) * umask(ji,jj,jk)        )   &
@@ -264,5 +264,5 @@
 
 !!an - calcul du gradient de pression horizontal (explicit)
-      DO_3D_00_00( 1, jpkm1 )
+      DO_3D( 0, 0, 0, 0, 1, jpkm1 )
          uu(ji,jj,jk,Nrhs) = uu(ji,jj,jk,Nrhs) - grav * ( ssh(ji+1,jj,Nnn) - ssh(ji,jj,Nnn) ) * r1_e1u(ji,jj)
          vv(ji,jj,jk,Nrhs) = vv(ji,jj,jk,Nrhs) - grav * ( ssh(ji,jj+1,Nnn) - ssh(ji,jj,Nnn) ) * r1_e2v(ji,jj)
@@ -271,5 +271,5 @@
       ! add wind stress forcing and layer linear friction to the RHS 
       z1_2rho0 = 0.5_wp * r1_rho0
-      DO_3D_00_00(1,jpkm1)
+      DO_3D( 0, 0, 0, 0,1,jpkm1)
          uu(ji,jj,jk,Nrhs) = uu(ji,jj,jk,Nrhs) + z1_2rho0 * ( utau_b(ji,jj) + utau(ji,jj) ) / e3u(ji,jj,jk,Nnn)   &
             &                                  - rn_rfr * uu(ji,jj,jk,Nbb)
@@ -280,5 +280,5 @@
                             CALL dom_qco_r3c   ( ssh(:,:,Naa), r3t(:,:,Naa), r3u(:,:,Naa), r3v(:,:,Naa), r3f(:,:) )   ! "after" ssh./h._0 ratio explicit      
       IF( ln_dynadv_vec ) THEN      ! vector invariant form : applied on velocity
-         DO_3D_11_11(1,jpkm1)
+         DO_3D( 1, 1, 1, 1,1,jpkm1)
             zua = uu(ji,jj,jk,Nbb) + rDt * uu(ji,jj,jk,Nrhs) * umask(ji,jj,jk)
             zva = vv(ji,jj,jk,Nbb) + rDt * vv(ji,jj,jk,Nrhs) * vmask(ji,jj,jk)
@@ -292,5 +292,5 @@
          !
       ELSE                          ! flux form : applied on thickness weighted velocity
-         DO_3D_11_11(1,jpkm1)
+         DO_3D( 1, 1, 1, 1,1,jpkm1)
             zue3n = e3u(ji,jj,jk,Nnn) * uu(ji,jj,jk,Nnn)
             zve3n = e3v(ji,jj,jk,Nnn) * vv(ji,jj,jk,Nnn)
Index: /NEMO/trunk/src/TOP/C14/trcatm_c14.F90
===================================================================
--- /NEMO/trunk/src/TOP/C14/trcatm_c14.F90	(revision 13294)
+++ /NEMO/trunk/src/TOP/C14/trcatm_c14.F90	(revision 13295)
@@ -120,5 +120,5 @@
             IF( ierr3 /= 0 )   CALL ctl_stop( 'STOP', 'trc_atm_c14_ini: unable to allocate fareaz' )
       !
-            DO_2D_11_11
+            DO_2D( 1, 1, 1, 1 )
               IF( gphit(ji,jj) >= yn40 ) THEN
                  fareaz(ji,jj,1) = 0.
Index: /NEMO/trunk/src/TOP/C14/trcsms_c14.F90
===================================================================
--- /NEMO/trunk/src/TOP/C14/trcsms_c14.F90	(revision 13294)
+++ /NEMO/trunk/src/TOP/C14/trcsms_c14.F90	(revision 13295)
@@ -81,5 +81,5 @@
       ! -------------------------------------------------------------------
 
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
          IF( tmask(ji,jj,1) >  0. ) THEN
             !
@@ -128,10 +128,10 @@
       !
       ! Add the surface flux to the trend of jp_c14
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
          tr(ji,jj,1,jp_c14,Krhs) = tr(ji,jj,1,jp_c14,Krhs) + qtr_c14(ji,jj) / e3t(ji,jj,1,Kmm) 
       END_2D
       !
       ! Computation of decay effects on jp_c14
-      DO_3D_11_11( 1, jpk )
+      DO_3D( 1, 1, 1, 1, 1, jpk )
          !
          tr(ji,jj,jk,jp_c14,Krhs) = tr(ji,jj,jk,jp_c14,Krhs) - rlam14 * tr(ji,jj,jk,jp_c14,Kbb) * tmask(ji,jj,jk) 
Index: /NEMO/trunk/src/TOP/C14/trcwri_c14.F90
===================================================================
--- /NEMO/trunk/src/TOP/C14/trcwri_c14.F90	(revision 13294)
+++ /NEMO/trunk/src/TOP/C14/trcwri_c14.F90	(revision 13295)
@@ -60,5 +60,5 @@
          zz3d(:,:,:) = 0._wp
          !
-         DO_3D_11_11( 1, jpkm1 )
+         DO_3D( 1, 1, 1, 1, 1, jpkm1 )
             IF( tmask(ji,jj,jk) > 0._wp) THEN
                z3d (ji,jj,jk) = tr(ji,jj,jk,jp_c14,Kmm)
@@ -71,5 +71,5 @@
          z2d(:,:) =0._wp
          jk = 1
-         DO_2D_11_11
+         DO_2D( 1, 1, 1, 1 )
             ztemp = zres(ji,jj) / c14sbc(ji,jj)
             IF( ztemp > 0._wp .AND. tmask(ji,jj,jk) > 0._wp ) z2d(ji,jj) = LOG( ztemp )
Index: /NEMO/trunk/src/TOP/CFC/trcini_cfc.F90
===================================================================
--- /NEMO/trunk/src/TOP/CFC/trcini_cfc.F90	(revision 13294)
+++ /NEMO/trunk/src/TOP/CFC/trcini_cfc.F90	(revision 13295)
@@ -132,5 +132,5 @@
       !---------------------------------------------------------------------------------------
       zyd = ylatn - ylats      
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
          IF(     gphit(ji,jj) >= ylatn ) THEN   ;   xphem(ji,jj) = 1.e0
          ELSEIF( gphit(ji,jj) <= ylats ) THEN   ;   xphem(ji,jj) = 0.e0
Index: /NEMO/trunk/src/TOP/CFC/trcsms_cfc.F90
===================================================================
--- /NEMO/trunk/src/TOP/CFC/trcsms_cfc.F90	(revision 13294)
+++ /NEMO/trunk/src/TOP/CFC/trcsms_cfc.F90	(revision 13295)
@@ -126,5 +126,5 @@
          
          !                                                         !------------!
-         DO_2D_11_11
+         DO_2D( 1, 1, 1, 1 )
  
             ! space interpolation
Index: /NEMO/trunk/src/TOP/PISCES/P2Z/p2zbio.F90
===================================================================
--- /NEMO/trunk/src/TOP/PISCES/P2Z/p2zbio.F90	(revision 13294)
+++ /NEMO/trunk/src/TOP/PISCES/P2Z/p2zbio.F90	(revision 13295)
@@ -122,5 +122,5 @@
       DO jk = 1, jpkbm1                      !  Upper ocean (bio-layers)  !
          !                                   ! -------------------------- !
-         DO_2D_00_00
+         DO_2D( 0, 0, 0, 0 )
             ! trophic variables( det, zoo, phy, no3, nh4, dom)
             ! ------------------------------------------------
@@ -242,5 +242,5 @@
       DO jk = jpkb, jpkm1                    !  Upper ocean (bio-layers)  !
          !                                   ! -------------------------- !
-         DO_2D_00_00
+         DO_2D( 0, 0, 0, 0 )
             ! remineralisation of all quantities towards nitrate 
 
Index: /NEMO/trunk/src/TOP/PISCES/P2Z/p2zexp.F90
===================================================================
--- /NEMO/trunk/src/TOP/PISCES/P2Z/p2zexp.F90	(revision 13294)
+++ /NEMO/trunk/src/TOP/PISCES/P2Z/p2zexp.F90	(revision 13295)
@@ -82,5 +82,5 @@
       ! LAYERS IS DETERMINED BY DMIN3 DEFINED IN sms_p2z.F90
       ! ----------------------------------------------------------------------
-      DO_3D_00_00( 1, jpkm1 )
+      DO_3D( 0, 0, 0, 0, 1, jpkm1 )
          ze3t = 1. / e3t(ji,jj,jk,Kmm)
          tr(ji,jj,jk,jpno3,Krhs) = tr(ji,jj,jk,jpno3,Krhs) + ze3t * dmin3(ji,jj,jk) * xksi(ji,jj)
@@ -93,5 +93,5 @@
       zgeolpoc = 0.e0         !     Initialization
       ! Release of nutrients from the "simple" sediment
-      DO_2D_00_00
+      DO_2D( 0, 0, 0, 0 )
          ikt = mbkt(ji,jj) 
          tr(ji,jj,ikt,jpno3,Krhs) = tr(ji,jj,ikt,jpno3,Krhs) + sedlam * sedpocn(ji,jj) / e3t(ji,jj,ikt,Kmm) 
@@ -103,5 +103,5 @@
       END_2D
 
-      DO_2D_00_00
+      DO_2D( 0, 0, 0, 0 )
          tr(ji,jj,1,jpno3,Krhs) = tr(ji,jj,1,jpno3,Krhs) + zgeolpoc * cmask(ji,jj) / areacot / e3t(ji,jj,1,Kmm)
       END_2D
@@ -121,5 +121,5 @@
       ELSE
         !
-        DO_2D_11_11
+        DO_2D( 1, 1, 1, 1 )
            zsedpocd = zsedpoca(ji,jj) - 2. * sedpocn(ji,jj) + sedpocb(ji,jj)      ! time laplacian on tracers
            sedpocb(ji,jj) = sedpocn(ji,jj) + rn_atfp * zsedpocd                     ! sedpocb <-- filtered sedpocn
@@ -174,5 +174,5 @@
       zdm0 = 0._wp
       zrro = 1._wp
-      DO_3D_11_11( jpkb, jpkm1 )
+      DO_3D( 1, 1, 1, 1, jpkb, jpkm1 )
          zfluo = ( gdepw(ji,jj,jk  ,Kmm) / gdepw(ji,jj,jpkb,Kmm) )**xhr
          zfluu = ( gdepw(ji,jj,jk+1,Kmm) / gdepw(ji,jj,jpkb,Kmm) )**xhr
@@ -191,5 +191,5 @@
       dminl(:,:)   = 0._wp
       dmin3(:,:,:) = zdm0
-      DO_3D_11_11( 1, jpk )
+      DO_3D( 1, 1, 1, 1, 1, jpk )
          IF( tmask(ji,jj,jk) == 0._wp ) THEN
             dminl(ji,jj) = dminl(ji,jj) + dmin3(ji,jj,jk)
@@ -198,5 +198,5 @@
       END_3D
 
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
          IF( tmask(ji,jj,1) == 0 )   dmin3(ji,jj,1) = 0._wp
       END_2D
@@ -204,5 +204,5 @@
       ! Coastal mask 
       cmask(:,:) = 0._wp
-      DO_2D_00_00
+      DO_2D( 0, 0, 0, 0 )
          IF( tmask(ji,jj,1) /= 0. ) THEN
             zmaskt = tmask(ji+1,jj,1) * tmask(ji-1,jj,1) * tmask(ji,jj+1,1) * tmask(ji,jj-1,1) 
Index: /NEMO/trunk/src/TOP/PISCES/P2Z/p2zopt.F90
===================================================================
--- /NEMO/trunk/src/TOP/PISCES/P2Z/p2zopt.F90	(revision 13294)
+++ /NEMO/trunk/src/TOP/PISCES/P2Z/p2zopt.F90	(revision 13295)
@@ -95,5 +95,5 @@
       !                                          ! Photosynthetically Available Radiation (PAR)
       zcoef = 12 * redf / rcchl / rpig           ! --------------------------------------
-      DO_3D_11_11( 2, jpk )
+      DO_3D( 1, 1, 1, 1, 2, jpk )
          zpig = LOG(  MAX( TINY(0.), tr(ji,jj,jk-1,jpphy,Kmm) ) * zcoef  )
          zkr  = xkr0 + xkrp * EXP( xlr * zpig )
@@ -102,5 +102,5 @@
          zparg(ji,jj,jk) = zparg(ji,jj,jk-1) * EXP( -zkg * e3t(ji,jj,jk-1,Kmm) )
       END_3D
-      DO_3D_11_11( 1, jpkm1 )
+      DO_3D( 1, 1, 1, 1, 1, jpkm1 )
          zpig = LOG(  MAX( TINY(0.), tr(ji,jj,jk,jpphy,Kmm) ) * zcoef  )
          zkr  = xkr0 + xkrp * EXP( xlr * zpig )
@@ -114,9 +114,9 @@
       !                                          ! --------------
       neln(:,:) = 1                                   ! euphotic layer level
-      DO_3D_11_11( 1, jpkm1 )
+      DO_3D( 1, 1, 1, 1, 1, jpkm1 )
         IF( etot(ji,jj,jk) >= zpar100(ji,jj) )   neln(ji,jj) = jk + 1 
       END_3D
       !                                               ! Euphotic layer depth
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
          heup(ji,jj) = gdepw(ji,jj,neln(ji,jj),Kmm)
       END_2D
Index: /NEMO/trunk/src/TOP/PISCES/P2Z/p2zsed.F90
===================================================================
--- /NEMO/trunk/src/TOP/PISCES/P2Z/p2zsed.F90	(revision 13294)
+++ /NEMO/trunk/src/TOP/PISCES/P2Z/p2zsed.F90	(revision 13295)
@@ -89,5 +89,5 @@
 
       ! tracer flux divergence at t-point added to the general trend
-      DO_3D_11_11( 1, jpkm1 )
+      DO_3D( 1, 1, 1, 1, 1, jpkm1 )
          ztra(ji,jj,jk)  = - ( zwork(ji,jj,jk) - zwork(ji,jj,jk+1) ) / e3t(ji,jj,jk,Kmm)
          tr(ji,jj,jk,jpdet,Krhs) = tr(ji,jj,jk,jpdet,Krhs) + ztra(ji,jj,jk) 
Index: /NEMO/trunk/src/TOP/PISCES/P4Z/p4zagg.F90
===================================================================
--- /NEMO/trunk/src/TOP/PISCES/P4Z/p4zagg.F90	(revision 13294)
+++ /NEMO/trunk/src/TOP/PISCES/P4Z/p4zagg.F90	(revision 13295)
@@ -60,5 +60,5 @@
       IF( ln_p4z ) THEN
          !
-         DO_3D_11_11( 1, jpkm1 )
+         DO_3D( 1, 1, 1, 1, 1, jpkm1 )
             !
             zfact = xstep * xdiss(ji,jj,jk)
@@ -102,5 +102,5 @@
       ELSE    ! ln_p5z
         !
-         DO_3D_11_11( 1, jpkm1 )
+         DO_3D( 1, 1, 1, 1, 1, jpkm1 )
             !
             zfact = xstep * xdiss(ji,jj,jk)
Index: /NEMO/trunk/src/TOP/PISCES/P4Z/p4zbc.F90
===================================================================
--- /NEMO/trunk/src/TOP/PISCES/P4Z/p4zbc.F90	(revision 13294)
+++ /NEMO/trunk/src/TOP/PISCES/P4Z/p4zbc.F90	(revision 13295)
@@ -112,5 +112,5 @@
       IF( ll_river ) THEN
           jl = n_trc_indcbc(jpno3)
-          DO_2D_11_11
+          DO_2D( 1, 1, 1, 1 )
              DO jk = 1, nk_rnf(ji,jj)
                 zcoef = rn_rfact / ( e1e2t(ji,jj) * h_rnf(ji,jj) * rn_cbc_time ) * tmask(ji,jj,1)
@@ -145,5 +145,5 @@
          ALLOCATE( zironice(jpi,jpj) )
          !
-         DO_2D_11_11
+         DO_2D( 1, 1, 1, 1 )
             zdep    = rfact / e3t(ji,jj,1,Kmm)
             zwflux  = fmmflx(ji,jj) / 1000._wp
@@ -297,5 +297,5 @@
          IF(lwp) WRITE(numout,*)
          IF(lwp) WRITE(numout,*) ' Level corresponding to 50m depth ',  ik50,' ', gdept_1d(ik50+1)
-         DO_3D_00_00( 1, ik50 )
+         DO_3D( 0, 0, 0, 0, 1, ik50 )
             ze3t   = e3t_0(ji,jj,jk)
             zsurfc =  e1u(ji,jj) * ( 1. - umask(ji  ,jj  ,jk) )   &
@@ -313,5 +313,5 @@
          CALL lbc_lnk( 'p4zbc', zcmask , 'T', 1.0_wp )      ! lateral boundary conditions on cmask   (sign unchanged)
          !
-         DO_3D_11_11( 1, jpk )
+         DO_3D( 1, 1, 1, 1, 1, jpk )
             zexpide   = MIN( 8.,( gdept(ji,jj,jk,Kmm) / 500. )**(-1.5) )
             zdenitide = -0.9543 + 0.7662 * LOG( zexpide ) - 0.235 * LOG( zexpide )**2
Index: /NEMO/trunk/src/TOP/PISCES/P4Z/p4zbio.F90
===================================================================
--- /NEMO/trunk/src/TOP/PISCES/P4Z/p4zbio.F90	(revision 13294)
+++ /NEMO/trunk/src/TOP/PISCES/P4Z/p4zbio.F90	(revision 13295)
@@ -72,5 +72,5 @@
       xdiss(:,:,:) = 1.
 !!gm the use of nmld should be better here?
-      DO_3D_11_11( 2, jpkm1 )
+      DO_3D( 1, 1, 1, 1, 2, jpkm1 )
 !!gm  :  use nmln  and test on jk ...  less memory acces
          IF( gdepw(ji,jj,jk+1,Kmm) > hmld(ji,jj) )   xdiss(ji,jj,jk) = 0.01
Index: /NEMO/trunk/src/TOP/PISCES/P4Z/p4zche.F90
===================================================================
--- /NEMO/trunk/src/TOP/PISCES/P4Z/p4zche.F90	(revision 13294)
+++ /NEMO/trunk/src/TOP/PISCES/P4Z/p4zche.F90	(revision 13295)
@@ -179,5 +179,5 @@
       ! 0.04°C relative to an exact computation
       ! ---------------------------------------------------------------------
-      DO_3D_11_11( 1, jpk )
+      DO_3D( 1, 1, 1, 1, 1, jpk )
          zpres = gdept(ji,jj,jk,Kmm) / 1000.
          za1 = 0.04 * ( 1.0 + 0.185 * ts(ji,jj,jk,jp_tem,Kmm) + 0.035 * (salinprac(ji,jj,jk) - 35.0) )
@@ -472,5 +472,5 @@
       IF( ln_timing )  CALL timing_start('ahini_for_at')
       !
-      DO_3D_11_11( 1, jpk )
+      DO_3D( 1, 1, 1, 1, 1, jpk )
       p_alkcb  = tr(ji,jj,jk,jptal,Kbb) * 1000. / (rhop(ji,jj,jk) + rtrn)
       p_dictot = tr(ji,jj,jk,jpdic,Kbb) * 1000. / (rhop(ji,jj,jk) + rtrn)
@@ -570,5 +570,5 @@
 
    ! TOTAL H+ scale: conversion factor for Htot = aphscale * Hfree
-   DO_3D_11_11( 1, jpk )
+   DO_3D( 1, 1, 1, 1, 1, jpk )
       IF (rmask(ji,jj,jk) == 1.) THEN
          p_alktot = tr(ji,jj,jk,jptal,Kbb) * 1000. / (rhop(ji,jj,jk) + rtrn)
@@ -599,5 +599,5 @@
 
    DO jn = 1, jp_maxniter_atgen 
-   DO_3D_11_11( 1, jpk )
+   DO_3D( 1, 1, 1, 1, 1, jpk )
       IF (rmask(ji,jj,jk) == 1.) THEN
          zfact = rhop(ji,jj,jk) / 1000. + rtrn
Index: /NEMO/trunk/src/TOP/PISCES/P4Z/p4zfechem.F90
===================================================================
--- /NEMO/trunk/src/TOP/PISCES/P4Z/p4zfechem.F90	(revision 13294)
+++ /NEMO/trunk/src/TOP/PISCES/P4Z/p4zfechem.F90	(revision 13295)
@@ -92,5 +92,5 @@
       ! Chemistry is supposed to be fast enough to be at equilibrium
       ! ------------------------------------------------------------
-      DO_3D_11_11( 1, jpkm1 )
+      DO_3D( 1, 1, 1, 1, 1, jpkm1 )
          zTL1(ji,jj,jk)  = ztotlig(ji,jj,jk)
          zkeq            = fekeq(ji,jj,jk)
@@ -107,5 +107,5 @@
 
       zdust = 0.         ! if no dust available
-      DO_3D_11_11( 1, jpkm1 )
+      DO_3D( 1, 1, 1, 1, 1, jpkm1 )
          ! Scavenging rate of iron. This scavenging rate depends on the load of particles of sea water. 
          ! This parameterization assumes a simple second order kinetics (k[Particles][Fe]).
@@ -177,5 +177,5 @@
       IF( ln_ligand ) THEN
          !
-         DO_3D_11_11( 1, jpkm1 )
+         DO_3D( 1, 1, 1, 1, 1, jpkm1 )
             zlam1a   = ( 0.369  * 0.3 * tr(ji,jj,jk,jpdoc,Kbb) + 102.4  * tr(ji,jj,jk,jppoc,Kbb) ) * xdiss(ji,jj,jk)    &
                 &    + ( 114.   * 0.3 * tr(ji,jj,jk,jpdoc,Kbb) )
Index: /NEMO/trunk/src/TOP/PISCES/P4Z/p4zflx.F90
===================================================================
--- /NEMO/trunk/src/TOP/PISCES/P4Z/p4zflx.F90	(revision 13294)
+++ /NEMO/trunk/src/TOP/PISCES/P4Z/p4zflx.F90	(revision 13295)
@@ -110,5 +110,5 @@
       IF( l_co2cpl )   satmco2(:,:) = atm_co2(:,:)
 
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
          ! DUMMY VARIABLES FOR DIC, H+, AND BORATE
          zfact = rhop(ji,jj,1) / 1000. + rtrn
@@ -126,5 +126,5 @@
       ! -------------------------------------------
 
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
          ztc  = MIN( 35., ts(ji,jj,1,jp_tem,Kmm) )
          ztc2 = ztc * ztc
@@ -145,5 +145,5 @@
 
 
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
          ztkel = tempis(ji,jj,1) + 273.15
          zsal  = salinprac(ji,jj,1) + ( 1.- tmask(ji,jj,1) ) * 35.
Index: /NEMO/trunk/src/TOP/PISCES/P4Z/p4zligand.F90
===================================================================
--- /NEMO/trunk/src/TOP/PISCES/P4Z/p4zligand.F90	(revision 13294)
+++ /NEMO/trunk/src/TOP/PISCES/P4Z/p4zligand.F90	(revision 13295)
@@ -52,5 +52,5 @@
       IF( ln_timing )   CALL timing_start('p4z_ligand')
       !
-      DO_3D_11_11( 1, jpkm1 )
+      DO_3D( 1, 1, 1, 1, 1, jpkm1 )
          !
          ! ------------------------------------------------------------------
Index: /NEMO/trunk/src/TOP/PISCES/P4Z/p4zlim.F90
===================================================================
--- /NEMO/trunk/src/TOP/PISCES/P4Z/p4zlim.F90	(revision 13294)
+++ /NEMO/trunk/src/TOP/PISCES/P4Z/p4zlim.F90	(revision 13295)
@@ -98,5 +98,5 @@
       IF( ln_timing )   CALL timing_start('p4z_lim')
       !
-      DO_3D_11_11( 1, jpkm1 )
+      DO_3D( 1, 1, 1, 1, 1, jpkm1 )
          
          ! Tuning of the iron concentration to a minimum level that is set to the detection limit
@@ -173,5 +173,5 @@
       ! Compute the fraction of nanophytoplankton that is made of calcifiers
       ! --------------------------------------------------------------------
-      DO_3D_11_11( 1, jpkm1 )
+      DO_3D( 1, 1, 1, 1, 1, jpkm1 )
          zlim1 =  ( tr(ji,jj,jk,jpno3,Kbb) * concnnh4 + tr(ji,jj,jk,jpnh4,Kbb) * concnno3 )    &
             &   / ( concnno3 * concnnh4 + concnnh4 * tr(ji,jj,jk,jpno3,Kbb) + concnno3 * tr(ji,jj,jk,jpnh4,Kbb) ) 
@@ -193,5 +193,5 @@
       END_3D
       !
-      DO_3D_11_11( 1, jpkm1 )
+      DO_3D( 1, 1, 1, 1, 1, jpkm1 )
          ! denitrification factor computed from O2 levels
          nitrfac(ji,jj,jk) = MAX(  0.e0, 0.4 * ( 6.e-6  - tr(ji,jj,jk,jpoxy,Kbb) )    &
Index: /NEMO/trunk/src/TOP/PISCES/P4Z/p4zlys.F90
===================================================================
--- /NEMO/trunk/src/TOP/PISCES/P4Z/p4zlys.F90	(revision 13294)
+++ /NEMO/trunk/src/TOP/PISCES/P4Z/p4zlys.F90	(revision 13295)
@@ -75,5 +75,5 @@
       CALL solve_at_general( zhinit, zhi, Kbb )
 
-      DO_3D_11_11( 1, jpkm1 )
+      DO_3D( 1, 1, 1, 1, 1, jpkm1 )
          zco3(ji,jj,jk) = tr(ji,jj,jk,jpdic,Kbb) * ak13(ji,jj,jk) * ak23(ji,jj,jk) / (zhi(ji,jj,jk)**2   &
             &             + ak13(ji,jj,jk) * zhi(ji,jj,jk) + ak13(ji,jj,jk) * ak23(ji,jj,jk) + rtrn )
@@ -87,5 +87,5 @@
       !     ---------------------------------------------------------
 
-      DO_3D_11_11( 1, jpkm1 )
+      DO_3D( 1, 1, 1, 1, 1, jpkm1 )
 
          ! DEVIATION OF [CO3--] FROM SATURATION VALUE
Index: /NEMO/trunk/src/TOP/PISCES/P4Z/p4zmeso.F90
===================================================================
--- /NEMO/trunk/src/TOP/PISCES/P4Z/p4zmeso.F90	(revision 13294)
+++ /NEMO/trunk/src/TOP/PISCES/P4Z/p4zmeso.F90	(revision 13295)
@@ -81,5 +81,5 @@
       IF( ln_timing )   CALL timing_start('p4z_meso')
       !
-      DO_3D_11_11( 1, jpkm1 )
+      DO_3D( 1, 1, 1, 1, 1, jpkm1 )
          zcompam   = MAX( ( tr(ji,jj,jk,jpmes,Kbb) - 1.e-9 ), 0.e0 )
          zfact     = xstep * tgfunc2(ji,jj,jk) * zcompam
Index: /NEMO/trunk/src/TOP/PISCES/P4Z/p4zmicro.F90
===================================================================
--- /NEMO/trunk/src/TOP/PISCES/P4Z/p4zmicro.F90	(revision 13294)
+++ /NEMO/trunk/src/TOP/PISCES/P4Z/p4zmicro.F90	(revision 13295)
@@ -79,5 +79,5 @@
       IF( ln_timing )   CALL timing_start('p4z_micro')
       !
-      DO_3D_11_11( 1, jpkm1 )
+      DO_3D( 1, 1, 1, 1, 1, jpkm1 )
          zcompaz = MAX( ( tr(ji,jj,jk,jpzoo,Kbb) - 1.e-9 ), 0.e0 )
          zfact   = xstep * tgfunc2(ji,jj,jk) * zcompaz
